//--- K.I.LIB ---
// kl_wnd.h : window information manager

#ifndef AFX_KIWINDOW_H__26105B94_1E36_42FA_8916_C2F7FB9EF994__INCLUDED_
#define AFX_KIWINDOW_H__26105B94_1E36_42FA_8916_C2F7FB9EF994__INCLUDED_

/*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*/
// kiWindow : WindoẘȒPȊǗ

class kiWindow
{
friend void kilib_startUp();

private: //-- O[oȏȂ ---------------------

	static void init();
	static void finish();

public: //-- OC^[tFCX --------------------------

	// ֘AtĂHWND
	HWND hwnd()
		{
			return m_hWnd;
		}

	// WindowpɃANZ[^[h
	void loadAccel( UINT id );

	// EChE܂cĂ邩ǂ`FbN
	bool isAlive()
		{
			if( !m_hWnd )
				return false;
			if( ::IsWindow(m_hWnd) )
				return true;
			m_hWnd = NULL;
			return false;
		}

	// e
	kiWindow* parent()
		{
			return kiwnd( ::GetParent( hwnd() ) );
		}

	// bZ[WM
	int sendMsg( UINT msg, WPARAM wp=0, LPARAM lp=0 )
		{
			return ::SendMessage( hwnd(), msg, wp, lp );
		}

	// [static] L[ɂ郁bZ[WSď
	static void msg();

	// [static] bZ[W[v܂킷B
	enum msglooptype {PEEK, GET};
	static void msgLoop( msglooptype type = GET );

	// [static] WindowI front 
	static void setFront( HWND wnd );

	// [static] Window𒆉
	static void setCenter( HWND wnd, HWND rel=NULL );

	// [static] HWND -> kiWindow (  )
	static kiWindow* kiwnd( HWND wnd )
		{
			kiWindow* ptr = (kiWindow*)::GetWindowLong( wnd, GWL_USERDATA );
			if( !ptr ) return NULL;
			if( ::IsBadCodePtr((FARPROC)&ptr) ) return NULL;
			return ptr;
		}

protected: //-- hNX -----------------------------

	// hNX́A쐬OɃRĂԂƁB
	static void preCreate( kiWindow* wnd )
		{ st_pCurInit = wnd; }
	// jOɃRĂԂƁB
	void detachHwnd();
	// GET/POSTbZ[W[v~
	static void loopbreak()
		{
			loopbreaker = true;
		}

private: //--  -------------------------------------

	// EChEnhݒ
	static LRESULT CALLBACK CBTProc( int code, WPARAM wp, LPARAM lp );
	static HHOOK st_hHook;
	static kiWindow* st_pCurInit;
	void setHwnd( HWND wnd )
		{
			m_hWnd = wnd;
		}

	// EChEێpϐ
	HWND m_hWnd;
	HACCEL m_hAccel;
	// _CAObZ[W
	virtual bool isDlgMsg( MSG* msg )
		{ return false; }
	// GET[vꎞ
	static bool loopbreaker;

protected:
	kiWindow();
public:
	virtual ~kiWindow();
};

/*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*/
// kiDialog : DialogkiWindowƂĊǗ

class kiDialog : public kiWindow
{
public: //-- OC^[tFCX --------------------------

	// [__CAOƂĎs
	virtual void doModal( HWND parent=NULL );

	// [hX_CAOƂč쐬
	virtual void createModeless( HWND parent=NULL );

	// IR[h擾
	UINT getEndCode()
		{
			return m_EndCode;
		}

	// [_ۂ
	bool isModal()
		{
			return m_bStateModal;
		}

	// _CAOACe
	int sendMsgToItem( UINT id, UINT msg, WPARAM wp=0, LPARAM lp=0 )
		{
			return ::SendDlgItemMessage( hwnd(), id, msg, wp, lp );
		}
	HWND item( UINT id )
		{
			return ::GetDlgItem( hwnd(), id );
		}

protected: //-- hNX -----------------------------

	// \[XIDŏ
	kiDialog( UINT id );

	// \[XID擾
	UINT getRsrcID()
		{
			return m_Rsrc;
		}

	// IR[hZbg
	void setEndCode( UINT endcode )
		{
			m_EndCode = endcode;
		}

	// [_ۂ̃tO"̂"ؑ
	void setState( bool modal )
		{
			m_bStateModal = modal;
		}

	// IR[hZbgāAI( IDOK nĂ onOK() ͌Ă΂ȂƂɒӁI )
	virtual void end( UINT endcode );

	// R}hEbZ[WɌĂ΂

		// nj -> onOK     -> if true end(IDOK)
		virtual bool onOK() {return true;}
		//  -> onCancel -> if true end(IDCANCEL)
		virtual bool onCancel() {return true;}
		// WM_INITDIALOG      -> onInit
		virtual BOOL onInit() {return FALSE;}
		// WM_????            -> proc
		virtual BOOL CALLBACK proc( UINT msg, WPARAM wp, LPARAM lp ) {return FALSE;}

private: //--  -------------------------------------

	UINT m_EndCode;
	UINT m_Rsrc;
	bool m_bStateModal;
	bool isDlgMsg( MSG* msg )
		{
			return (!!::IsDialogMessage( hwnd(), msg ));
		}
	static BOOL CALLBACK commonDlg( HWND dlg, UINT msg, WPARAM wp, LPARAM lp );
};

/*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*/
// kiPropSheet : PropertySheetkiWindowƂĊǗB

#define IDAPPLY      (0x3021)
#define ID_KIPS_HELP (0x0009)

class kiPropSheetPage : public kiDialog
{
friend class kiPropSheet;

protected: //-- hNX ----------------------------

	// _CAOACRIDŏ
	kiPropSheetPage( UINT dlgid )
		: kiDialog( dlgid ), m_hIcon( NULL ) {}
	void setIcon( HICON h )
		{ m_hIcon = h; }

	// nj/Kp -> page::onOK -> sheet::onOK -> (if ok I)
	// virtual bool onOK()
	// WM_INITDIALOG
	// virtual BOOL onInit()
	// ̑
	// virtual BOOL CALLBACK proc( UINT msg, WPARAM wp, LPARAM lp )

private: //--  -------------------------------------

	void end( UINT endcode ) {}
	void setInfo( PROPSHEETPAGE* p );
	HICON m_hIcon;
};

class kiPropSheet : public kiDialog
{
friend class kiPropSheetPage;

public: //-- OC^[tFCX --------------------------

	// [__CAOƂĎs
	void doModal( HWND parent );

	// [hX_CAOƂč쐬
	void createModeless( HWND parent );

protected: //-- hNX ----------------------------

	// RXgN^ӂŁׂ
	PROPSHEETHEADER m_Header;
	kiArray<kiPropSheetPage*> m_Pages;

	// I
	void end( UINT endcode );
	// 
	void sendOK2All()
	{
		for( unsigned int i=0;i!=m_Pages.len(); i++ )
			if( m_Pages[i]->isAlive() )
				m_Pages[i]->onOK();
	}

	// nj/Kp -> page::onOK -> sheet::onOK -> (if ok I)
	// virtual void onOK()
	// LZ -> sheet::onCancel -> I
	// virtual void onCancel()
	// PSCB_INITIALIZED
	// virtual BOOL onInit()
	// Kp
	virtual void onApply() {}
	// wv
	virtual void onHelp() {}
	// ̑R}h
	virtual void onCommand( UINT id ) {}
	// t@Chbv
	virtual void onDrop( HDROP hdrop ) {}

private: //--  ---------------------------------------

	void begin();
	bool m_bStateModal;

	static kiPropSheet* st_CurInitPS;
	WNDPROC m_DefProc;
	bool isDlgMsg( MSG* msg )
		{ return !!PropSheet_IsDialogMessage( hwnd(),msg ); }
	static int CALLBACK main_initProc( HWND dlg, UINT msg, LPARAM lp );
	static LRESULT CALLBACK main_cmmnProc( HWND dlg, UINT msg, WPARAM wp, LPARAM lp );
	static BOOL CALLBACK page_cmmnProc( HWND dlg, UINT msg, WPARAM wp, LPARAM lp );
	static UINT CALLBACK page_initProc( HWND dlg, UINT msg, LPPROPSHEETPAGE ppsp );

protected:
	kiPropSheet();
public:
	~kiPropSheet()
		{ for( unsigned int i=0; i!=m_Pages.len(); i++ ) delete m_Pages[i]; }
};

/*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*/
// kiListView : ListViewRg[̊ȒPȃbp

class kiListView
{
public:
	kiListView( kiDialog* dlg, UINT id )
		{
			m_hWnd = ::GetDlgItem( dlg->hwnd(), id );
		}

	void insertColumn( int y, const char* title,
						int width=100, int fmt=LVCFMT_LEFT )
		{
			LVCOLUMN col;
			col.mask = LVCF_TEXT | LVCF_FMT | LVCF_WIDTH;
			col.pszText = const_cast<char*>(title);
			col.cx = width;
			col.fmt = fmt;
			::SendMessage( m_hWnd, LVM_INSERTCOLUMN, y, (LPARAM)&col );
		}

	void insertItem( int x, const char* str, LPARAM param=0, int iImage=-1 )
		{
			LVITEM item;
			item.mask = LVIF_TEXT | LVIF_PARAM | (iImage!=-1 ? LVIF_IMAGE : 0);
			item.pszText = const_cast<char*>(str);
			item.iItem = x;
			item.iSubItem = 0;
			item.iImage = iImage;
			item.lParam = param; 
			::SendMessage( m_hWnd, LVM_INSERTITEM, 0, (LPARAM)&item );
		}

	void setSubItem( int x, int y, const char* str )
		{
			LVITEM item;
			item.mask = LVIF_TEXT;
			item.pszText = const_cast<char*>(str);
			item.iItem = x;
			item.iSubItem = y;
			::SendMessage( m_hWnd, LVM_SETITEM, 0, (LPARAM)&item );
		}

	void setImageList( HIMAGELIST Large, HIMAGELIST Small )
		{
			::SendMessage( m_hWnd, LVM_SETIMAGELIST, LVSIL_NORMAL, (LPARAM)Large );
			::SendMessage( m_hWnd, LVM_SETIMAGELIST, LVSIL_SMALL,  (LPARAM)Small );
		}

private:
	HWND m_hWnd;
};

#endif
